mcast6-pktfld02 6.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast6-pktfld02
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining plural IPv6 multicast
  28. # groups on separate sockets, then receiving a large number of UDP packets at
  29. # the each socket
  30. #
  31. # Setup:
  32. # See testcases/network/stress/README
  33. #
  34. # Author:
  35. # Mitsuru Chinen <mitch@jp.ibm.com>
  36. #
  37. # History:
  38. # May 1 2006 - Created (Mitsuru Chinen)
  39. #
  40. #-----------------------------------------------------------------------
  41. # Uncomment line below for debug output.
  42. #trace_logic=${trace_logic:-"set -x"}
  43. $trace_logic
  44. # The test case ID, the test case count and the total number of test case
  45. TCID=mcast6-pktfld02
  46. TST_TOTAL=1
  47. TST_COUNT=1
  48. export TCID
  49. export TST_COUNT
  50. export TST_TOTAL
  51. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  52. export LTPROOT
  53. # Check the environmanet variable
  54. . check_envval || exit $TST_TOTAL
  55. # Dulation of the test [sec]
  56. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  57. # The number of the test link where tests run
  58. LINK_NUM=${LINK_NUM:-0}
  59. # Network portion of the IPv6 address
  60. NETWORK_PART="fec0:1:1:1"
  61. # Host portion of the IPv6 address
  62. LHOST_HOST_PART=":2" # local host
  63. RHOST_HOST_PART=":1" # remote host
  64. # Prefix of the multicast address
  65. MCAST_ADDR_PREFIX=ff0e::1111
  66. # Number of the multicast connection
  67. MCASTNUM_NORMAL=${MCASTNUM_NORMAL:-20}
  68. #-----------------------------------------------------------------------
  69. #
  70. # Function: do_cleanup
  71. #
  72. # Description:
  73. # Recover the system configuration
  74. #
  75. #-----------------------------------------------------------------------
  76. do_cleanup()
  77. {
  78. # Make sure to kill the multicast receiver and sender
  79. killall -SIGHUP ns-mcast_receiver >/dev/null 2>&1
  80. $LTP_RSH $RHOST killall -SIGHUP ns-udpsender >/dev/null 2>&1
  81. # Clean up each interface
  82. initialize_if lhost ${LINK_NUM}
  83. initialize_if rhost ${LINK_NUM}
  84. }
  85. #-----------------------------------------------------------------------
  86. #
  87. # Function: do_setup
  88. #
  89. # Description:
  90. # Configure the ssystem for the test
  91. #
  92. #-----------------------------------------------------------------------
  93. do_setup()
  94. {
  95. # Initialize the system configuration
  96. do_cleanup
  97. # Call do_cleanup function before exit
  98. trap do_cleanup 0
  99. # Unset the maximum number of processes
  100. ulimit -u unlimited
  101. # name of interface of the local/remote host
  102. lhost_ifname=`get_ifname lhost $LINK_NUM`
  103. if [ $? -ne 0 ]; then
  104. tst_resm TBROK "Failed to get the interface name at the local host"
  105. exit $TST_TOTAL
  106. fi
  107. rhost_ifname=`get_ifname rhost $LINK_NUM`
  108. if [ $? -ne 0 ]; then
  109. tst_resm TBROK "Failed to get the interface name at the remote host"
  110. exit $TST_TOTAL
  111. fi
  112. # Set IPv6 addresses to the interfaces
  113. add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  114. if [ $? -ne 0 ]; then
  115. tst_resm TBROK "Failed to add any IP address at the local host"
  116. exit 1
  117. fi
  118. add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  119. if [ $? -ne 0 ]; then
  120. tst_resm TBROK "Failed to add any IP address at the remote host"
  121. exit 1
  122. fi
  123. # IPv6 address of the local/remote host
  124. lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
  125. rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
  126. # Make sure the connectvity
  127. check_icmpv6_connectivity $lhost_ifname $rhost_addr
  128. if [ $? -ne 0 ]; then
  129. tst_resm TBROK "There is no IPv6 connectivity."
  130. exit 1
  131. fi
  132. # Make sure the sysctl values
  133. sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
  134. if [ $? -ne 0 ]; then
  135. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  136. exit $TST_TOTAL
  137. fi
  138. sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
  139. sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
  140. }
  141. #-----------------------------------------------------------------------
  142. #
  143. # Main
  144. #
  145. #
  146. # Test description
  147. tst_resm TINFO "Verify that the kernel is not crashed when joining $MCASTNUM_NORMAL IPv6 multicast groups on separate sockets, then receiving a large number of UDP packets at the each socket in $NS_DURATION [sec]"
  148. # Make sure the value of LTPROOT
  149. do_setup
  150. mcastnum=0
  151. mcast_port_range=`find_portbundle udp 1025 $MCASTNUM_NORMAL`
  152. if [ $? -ne 0 ]; then
  153. tst_resm TBROK "Failed to get enough port"
  154. exit 1
  155. fi
  156. mcast_port_top=`echo $mcast_port_range | cut -f 1 -d '-'`
  157. while [ $mcastnum -lt $MCASTNUM_NORMAL ]; do
  158. # Define the multicast address
  159. if [ $mcastnum -gt 65535 ]; then
  160. tst_resm TINFO "The number of the connection is less than 65535"
  161. break
  162. fi
  163. mcastnum_hex=`printf "%x" $mcastnum`
  164. mcast_addr=${MCAST_ADDR_PREFIX}:${mcastnum_hex}
  165. # Run a receiver
  166. mcast_port=`expr $mcast_port_top + $mcastnum`
  167. ns-mcast_receiver -f 6 -I $lhost_ifname -m $mcast_addr -p $mcast_port -b
  168. if [ $? -ne 0 ]; then
  169. tst_resm TBROK "Failed to start multicast receiver"
  170. exit 1
  171. fi
  172. # Run a sender
  173. $LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-udpsender -D $mcast_addr -f 6 -p $mcast_port -m -I $rhost_ifname -b -t $NS_DURATION
  174. mcastnum=`expr $mcastnum + 1`
  175. done
  176. sleep $NS_DURATION
  177. do_cleanup
  178. #-----------------------------------------------------------------------
  179. #
  180. # Clean up
  181. #
  182. tst_resm TPASS "Test is finished successfully."
  183. exit 0